using Bp.Sync.BackEnd.Infrastructure.Repositories;
using Bp.Sync.Domain.Entities.Inventories.Products;
using Bp.Sync.Dto.Results;
using CommonLibrary;
using Dapper;
using EasyNetQ;
using MediatR;
using Microsoft.Extensions.Configuration;
using System;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Vina.Search.Infrastructure.Mappings;

namespace Bp.Sync.BackEnd.Application.Commands.Inventories.Products
{
    public class SyncProductHandler : IRequestHandler<SyncProductCommand, BaseResult>
    {
        private readonly IDbConnection _dbConnection;
        private readonly IProductRepository _ProductRepository;
        private readonly IBus _bus;

        public SyncProductHandler(IConfiguration configuration, IProductRepository ProductRepository, IBus bus)
        {
            var connectionString = configuration.GetConnectionString("InventoryConnection");
            _dbConnection = new SqlConnection(connectionString);
            _ProductRepository = ProductRepository;
            _bus = bus;
        }

        public async Task<BaseResult> Handle(SyncProductCommand request, CancellationToken cancellationToken)
        {
            var rs = new BaseResult();

            if (request.Ids.Count() > 1000)
            {
                var length = request.Ids.Count();
                if (length > 0)
                {
                    for (int i = 0; i <= length / 1000; i++)
                    {
                        if (length > i * 1000)
                        {
                            var ids = request.Ids.Skip(i * 1000).Take(1000).ToList();
                            if (ids.Count() > 0)
                            {
                                await _bus.SendAsync($"SyncToElasticProduct0", ids.ConvertListLongToString());
                            }
                        }
                    }
                }
                return new BaseResult { Result = Result.Success, Message = $"sent {length} Products" };
            }
            if (!request.Ids.Any())
            {
                rs.Message = $"no data to update";
                rs.Result = Dto.Results.Result.Success;
                return rs;
            }
            try
            {
                var p = new Dto.DapperTypes.IdsParam(request.Ids);
                var products = await _dbConnection.QueryAsync<Product>("Sync_Product_Get_By_List_Id", p, commandType: CommandType.StoredProcedure);
                if (products.Any())
                {
                    //lấy ra trạng thái của đưn hàng
                    var suplierids = products.Select(x => (long)x.SupplierId).Distinct().ToList();
                    var suplierparam = new Dto.DapperTypes.IdsParam(suplierids);
                    var suppliers = await _dbConnection.QueryAsync<Domain.Entities.Inventories.Suppliers.Supplier>("Sync_Supplier_Get_By_List_Id", suplierparam, commandType: CommandType.StoredProcedure);

                    var ProductRs = products.ToProducts();
                    foreach (var item in ProductRs)
                    {
                        var sup = suppliers.FirstOrDefault(x => x.Id == item.SupplierId);
                        if (sup != null) item.SupplierType = sup.SupplierType;
                    }

                    var rs2 = await _ProductRepository.AddManyAsync(ProductRs);
                    if (rs2.Result == Result.Success)
                    {
                        await _dbConnection.ExecuteAsync("Synced_Product_By_List_Id", p, commandType: CommandType.StoredProcedure);
                        rs.Message = $"{ProductRs.Count()} synced";
                        rs.Result = Result.Success;
                    }
                    else
                    {
                        rs.Message = $"can not insert db";
                        rs.Result = Result.Success;
                    }
                }
                else
                {
                    rs.Message = $"no data to update";
                    rs.Result = Result.Success;
                }
            }
            catch (Exception ex)
            {
                rs.Message = ex.Message.ToString();
                rs.Result = Result.SystemError;
            }
            return rs;
        }
    }
}